Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports NorthwindLibrary
Imports Telerik.WinControls.UI

Namespace WinFormsApplication
	Public Partial Class CategoryForm
		Inherits Form
		Public Sub New()
			Me.InitializeComponent()
		End Sub

		Public ReadOnly Property SelectedCategory() As Category
			Get
				If Me.CategoryRadGridView.CurrentRow Is Nothing Then
					Return Nothing
				End If
				Return TryCast(Me.CategoryRadGridView.CurrentRow.DataBoundItem, Category)
			End Get
		End Property

		Public Property CategorySource() As IEnumerable(Of Category)
			Get
				Return TryCast(Me.CategoryBindingSource.DataSource, IEnumerable(Of Category))
			End Get
			Set
				Me.CategoryBindingSource.DataSource = Value
				Me.CategoryRadGridView.DataSource = Me.CategoryBindingSource
			End Set
		End Property

		Public Custom Event DataSourceCollectionChanged As ListChangedEventHandler
			AddHandler(ByVal value As ListChangedEventHandler)
				AddHandler Me.CategoryBindingSource.ListChanged, value
			End AddHandler
			RemoveHandler(ByVal value As ListChangedEventHandler)
				RemoveHandler Me.CategoryBindingSource.ListChanged, value
			End RemoveHandler
			RaiseEvent(ByVal sender As System.Object, ByVal e As System.ComponentModel.ListChangedEventArgs)
			End RaiseEvent
		End Event

		Public Custom Event SaveChangesButtonClicked As EventHandler
			AddHandler(ByVal value As EventHandler)
				AddHandler Me.SaveChangesButton.Click, value
			End AddHandler
			RemoveHandler(ByVal value As EventHandler)
				RemoveHandler Me.SaveChangesButton.Click, value
			End RemoveHandler
			RaiseEvent(ByVal sender As System.Object, ByVal e As System.EventArgs)
			End RaiseEvent
		End Event

		Public Custom Event RowsChanging As GridViewCollectionChangingEventHandler
			AddHandler(ByVal value As GridViewCollectionChangingEventHandler)
				AddHandler Me.CategoryRadGridView.RowsChanging, value
			End AddHandler
			RemoveHandler(ByVal value As GridViewCollectionChangingEventHandler)
				RemoveHandler Me.CategoryRadGridView.RowsChanging, value
			End RemoveHandler
			RaiseEvent(ByVal sender As System.Object, ByVal e As Telerik.WinControls.UI.GridViewCollectionChangingEventArgs)
			End RaiseEvent
		End Event

		Public Custom Event CategoryFormClosed As FormClosedEventHandler
			AddHandler(ByVal value As FormClosedEventHandler)
				AddHandler Me.FormClosed, value
			End AddHandler
			RemoveHandler(ByVal value As FormClosedEventHandler)
				RemoveHandler Me.FormClosed, value
			End RemoveHandler
			RaiseEvent(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs)
			End RaiseEvent
		End Event

		Public Sub ConfigureGrid()
			Me.CategoryRadGridView.Columns(0).IsVisible = False
			Dim numberOfColumns As Integer = Me.CategoryRadGridView.Columns.Count
			Me.CategoryRadGridView.Columns(numberOfColumns - 1).IsVisible = False

			Me.CategoryRadGridView.MasterGridViewTemplate.BestFitColumns()
		End Sub

		Public Sub EndEdit()
			Me.CategoryRadGridView.EndEdit()
			Me.CategoryBindingSource.EndEdit()
		End Sub
	End Class
End Namespace
